﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using WP7_WritingAndReadingFromIsolatedStorage.Models;
using WP7_WritingAndReadingFromIsolatedStorage.Storage;

namespace WP7_WritingAndReadingFromIsolatedStorage
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void WriteButton_Click( object sender, RoutedEventArgs e )
        {
            var person = new Person
                             {
                                 FirstName = "Dimecast",
                                 LastName = "Demo",
                                 EmailAddresseses = new ObservableCollection<EmailAddresses>
                                                        {
                                                            new EmailAddresses {Type = "Personal", Address = "d@d.com"},
                                                            new EmailAddresses {Type = "Personal", Address = "d@d.com"}
                                                        }
                             };

            new DataContractIsolatedStorageHelper().WriteToFile( person );
        }

        private void ReadButton_Click( object sender, RoutedEventArgs e )
        {
            var person = new DataContractIsolatedStorageHelper().ReadFromFile<Person>();


        }

        private void WriteXmlButton_Click( object sender, RoutedEventArgs e )
        {
            var person = new Person
            {
                FirstName = "Dimecast",
                LastName = "Demo",
                EmailAddresseses = new ObservableCollection<EmailAddresses>
                                                        {
                                                            new EmailAddresses {Type = "Personal", Address = "d@d.com"},
                                                            new EmailAddresses {Type = "Personal", Address = "d@d.com"}
                                                        }
            };

            new XmlIsolatedStorageHelper().WriteToFile( person );
        }

        private void ReadXmlButton_Click( object sender, RoutedEventArgs e )
        {
            var person = new XmlIsolatedStorageHelper().ReadFromFile<Person>();
        }

        private void ReadRawButton_Click( object sender, RoutedEventArgs e )
        {
            var rawXml = new XmlIsolatedStorageHelper().ReadFromFileRaw();
            var rawDataContract = new DataContractIsolatedStorageHelper().ReadFromFileRaw();
        }
    }
}