﻿using System.IO;
using System.IO.IsolatedStorage;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace WP7_WritingAndReadingFromIsolatedStorage.Storage
{
    public class DataContractIsolatedStorageHelper
    {
        public void WriteToFile<T>(T model )
        {
            using ( var storage = IsolatedStorageFile.GetUserStoreForApplication() )
            {
                using ( var stream = new IsolatedStorageFileStream( "dimecasts.data",
                    FileMode.OpenOrCreate, storage) )
                {
                    var serializer = new DataContractSerializer( typeof( T ) );
                    serializer.WriteObject( stream, model );
                }
            }
        }

        public T ReadFromFile<T>()
        {
            using ( var storage = IsolatedStorageFile.GetUserStoreForApplication() )
            {
                using ( var stream = new IsolatedStorageFileStream( "dimecasts.data",
                    FileMode.OpenOrCreate, storage ) )
                {
                    var serializer = new DataContractSerializer( typeof( T ) );
                    var readModel = (T)serializer.ReadObject( stream );

                    return readModel;
                }
            }
        }

        public string ReadFromFileRaw()
        {
            using ( var storage = IsolatedStorageFile.GetUserStoreForApplication() )
            {
                using ( var stream = new IsolatedStorageFileStream( "dimecasts.data", FileMode.OpenOrCreate, storage ) )
                {
                    var reader = new StreamReader( stream );

                    var data = reader.ReadToEnd();
                    return data;
                }
            }
        }
    }

    public class XmlIsolatedStorageHelper
    {
        public void WriteToFile<T>( T model )
        {
            using ( var storage = IsolatedStorageFile.GetUserStoreForApplication() )
            {
                using ( var stream = new IsolatedStorageFileStream( "dimecasts.xdata",
                    FileMode.OpenOrCreate, storage ) )
                {
                    var serializer = new XmlSerializer( typeof( T ) );
                    serializer.Serialize( stream, model );
                }
            }
        }

        public T ReadFromFile<T>()
        {
            using ( var storage = IsolatedStorageFile.GetUserStoreForApplication() )
            {
                using ( var stream = new IsolatedStorageFileStream( "dimecasts.xdata",
                    FileMode.OpenOrCreate, storage ) )
                {
                    var serializer = new XmlSerializer( typeof( T ) );
                    var readModel = (T)serializer.Deserialize( stream );

                    return readModel;
                }
            }
        }

        public string ReadFromFileRaw()
        {
            using ( var storage = IsolatedStorageFile.GetUserStoreForApplication() )
            {
                using ( var stream = new IsolatedStorageFileStream( "dimecasts.xdata", FileMode.OpenOrCreate, storage ) )
                {
                    var reader = new StreamReader( stream );

                    var data = reader.ReadToEnd();
                    return data;
                }
            }
        }
    }
}
